import serial
import time
import re

def print_bts(bts):
    for n in bts:
        print("{0:0{1}X}".format(n,2), end = " ")
    print()


print('Checking Sensor')

while True:
    state = 0
    bts = b''
    ser = serial.Serial('COM28', 9600, timeout = 3)
    tik = time.time()
    while(time.time() - tik < 7):
        bt = ser.read()
        print(bt.decode("utf-8"), end = '',  flush=True)
        
        if(state == 0 and bt == b'R'):
            print()
            print('Sensor Ready')
            state = 1
            ser.write(b'QA')
        elif(state == 1):
            bts += bt
            
    ser.close()
    rspstr = bts.decode("utf-8")
    vals = rspstr.split('\n')
    
    try:
        vel = vals[0].split()[1]
        dist = vals[1].split()[1]
        amp = vals[2].split()[1]
        spread = vals[3].split()[1]
        angle = vals[4].split()[1]
        peaks = vals[5].split()[1]
    
        peaks = peaks.split('|')
        peaks = [int(x, 16) for x in peaks]
        pdist = [x >> 16 for x in peaks]
        pamps = [x & 0xFFFF for x in peaks]
        
    
        print('========= RESULTS ========')
        print('velocity: ', vel, ' mm/s')
        print('distance: ', dist, ' mm')
        print('amplitude: ', amp)
        print('spread: ', spread)
        print('angle: ', angle, ' deg')
        for a,d in zip(pamps,pdist):
            print('peak: ', d, "mm  | amplitude: ", a)
        print()
    
    except IndexError:
        pass
        
    

    
    print('Resetting')
    print('============================')


